import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["extensions", "value", "selection", "onChange"];
import { useEffect } from 'react';
import { StateEffect, Annotation } from '@codemirror/state';
import { EditorView } from '@codemirror/view';
import { getDefaultExtensions } from '@uiw/react-codemirror';
import { useStore } from './store';
var External = Annotation.define();
export var Original = props => {
  var {
      extensions = [],
      value,
      selection,
      onChange
    } = props,
    otherOption = _objectWithoutPropertiesLoose(props, _excluded);
  var {
    original,
    view,
    theme,
    dispatch
  } = useStore();
  var defaultExtensions = getDefaultExtensions(_extends({}, otherOption, {
    theme
  }));
  var updateListener = EditorView.updateListener.of(vu => {
    if (vu.docChanged && typeof onChange === 'function' &&
    // Fix echoing of the remote changes:
    // If transaction is market as remote we don't have to call `onChange` handler again
    !vu.transactions.some(tr => tr.annotation(External))) {
      var doc = vu.state.doc;
      var val = doc.toString();
      onChange(val, vu);
    }
  });
  var extensionsData = [updateListener, ...defaultExtensions, ...extensions];
  var data = {
    extensions: [...extensionsData]
  };
  useEffect(() => {
    dispatch({
      original: _extends({
        doc: value,
        selection: selection
      }, data),
      originalExtension: {
        option: otherOption,
        extension: [updateListener, extensions]
      }
    });
  }, []);
  useEffect(() => dispatch({
    originalExtension: {
      option: otherOption,
      extension: [updateListener, extensions]
    }
  }), [props]);
  useEffect(() => {
    if ((original == null ? void 0 : original.doc) !== value && view) {
      data.doc = value;
      dispatch({
        original: _extends({}, original, data)
      });
      var originalDoc = view == null ? void 0 : view.a.state.doc.toString();
      if (originalDoc !== value) {
        view == null ? void 0 : view.a.dispatch({
          changes: {
            from: 0,
            to: (originalDoc || '').length,
            insert: value || ''
          },
          effects: StateEffect.reconfigure.of([...extensionsData]),
          annotations: [External.of(true)]
        });
      }
    }
    if ((original == null ? void 0 : original.selection) !== selection) {
      data.selection = selection;
      dispatch({
        original: _extends({}, original, data)
      });
    }
  }, [value, selection, view]);
  return null;
};
Original.displayName = 'CodeMirrorMerge.Original';